MemoryCacheImageInputStream (Java Platform SE 8 )
Keywords: javax.imageio.stream.MemoryCacheImageInputStream class
Date: 2026-04-17

javax.imageio.stream

## Class MemoryCacheImageInputStream

- java.lang.Object
- - javax.imageio.stream.ImageInputStreamImpl
  - - javax.imageio.stream.MemoryCacheImageInputStream

- All Implemented Interfaces:
    Closeable, DataInput, AutoCloseable, ImageInputStream

      public class MemoryCacheImageInputStream
      extends ImageInputStreamImpl

  An implementation of `ImageInputStream` that gets its input from a regular `InputStream`. A memory buffer is used to cache at least the data between the discard position and the current read position.

  In general, it is preferable to use a `FileCacheImageInputStream` when reading from a regular `InputStream`. This class is provided for cases where it is not possible to create a writable temporary file.

- - ### Field Summary

    - ### Fields inherited from class javax.imageio.stream.ImageInputStreamImpl

      `bitOffset, byteOrder, flushedPos, streamPos`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MemoryCacheImageInputStream(InputStream stream)` Constructs a `MemoryCacheImageInputStream` that will read from a given `InputStream`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes this `MemoryCacheImageInputStream`, freeing the cache.
    `protected void` | `finalize()` Finalizes this object prior to garbage collection.
    `void` | `flushBefore(long pos)` Discards the initial portion of the stream prior to the indicated position.
    `boolean` | `isCached()` Returns `true` since this `ImageInputStream` caches data in order to allow seeking backwards.
    `boolean` | `isCachedFile()` Returns `false` since this `ImageInputStream` does not maintain a file cache.
    `boolean` | `isCachedMemory()` Returns `true` since this `ImageInputStream` maintains a main memory cache.
    `int` | `read()` Reads a single byte from the stream and returns it as an `int` between 0 and 255.
    `int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`.

    - ### Methods inherited from class javax.imageio.stream.ImageInputStreamImpl

      `checkClosed, flush, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, length, mark, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, seek, setBitOffset, setByteOrder, skipBytes, skipBytes`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MemoryCacheImageInputStream

          public MemoryCacheImageInputStream(InputStream stream)

      Constructs a `MemoryCacheImageInputStream` that will read from a given `InputStream`.
      Parameters:
        `stream` - an `InputStream` to read from.
      Throws:
        `IllegalArgumentException` - if `stream` is `null`.

  - ### Method Detail

    - #### read

          public int read()
                   throws IOException

      Description copied from class: `ImageInputStreamImpl`
      Reads a single byte from the stream and returns it as an `int` between 0 and 255. If EOF is reached, `-1` is returned.

      Subclasses must provide an implementation for this method. The subclass implementation should update the stream position before exiting.

      The bit offset within the stream must be reset to zero before the read occurs.

      Specified by:
        `read` in interface `ImageInputStream`
      Specified by:
        `read` in class `ImageInputStreamImpl`
      Returns:
        the value of the next byte in the stream, or `-1` if EOF is reached.
      Throws:
        `IOException` - if the stream has been closed.

    - #### read

          public int read(byte[] b,
                          int off,
                          int len)
                   throws IOException

      Description copied from class: `ImageInputStreamImpl`
      Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`. If no bytes can be read because the end of the stream has been reached, `-1` is returned.

      The bit offset within the stream must be reset to zero before the read occurs.

      Subclasses must provide an implementation for this method. The subclass implementation should update the stream position before exiting.

      Specified by:
        `read` in interface `ImageInputStream`
      Specified by:
        `read` in class `ImageInputStreamImpl`
      Parameters:
        `b` - an array of bytes to be written to.
        `off` - the starting position within `b` to write to.
        `len` - the maximum number of bytes to read.
      Returns:
        the number of bytes actually read, or `-1` to indicate EOF.
      Throws:
        `IOException` - if an I/O error occurs.

    - #### flushBefore

          public void flushBefore(long pos)
                           throws IOException

      Description copied from interface: `ImageInputStream`
      Discards the initial portion of the stream prior to the indicated position. Attempting to seek to an offset within the flushed portion of the stream will result in an `IndexOutOfBoundsException`.

      Calling `flushBefore` may allow classes implementing this interface to free up resources such as memory or disk space that are being used to store data from the stream.

      Specified by:
        `flushBefore` in interface `ImageInputStream`
      Overrides:
        `flushBefore` in class `ImageInputStreamImpl`
      Parameters:
        `pos` - a `long` containing the length of the stream prefix that may be flushed.
      Throws:
        `IOException` - if an I/O error occurs.

    - #### isCached

          public boolean isCached()

      Returns `true` since this `ImageInputStream` caches data in order to allow seeking backwards.
      Specified by:
        `isCached` in interface `ImageInputStream`
      Overrides:
        `isCached` in class `ImageInputStreamImpl`
      Returns:
        `true`.
      See Also:
        `isCachedMemory()`, `isCachedFile()`

    - #### isCachedFile

          public boolean isCachedFile()

      Returns `false` since this `ImageInputStream` does not maintain a file cache.
      Specified by:
        `isCachedFile` in interface `ImageInputStream`
      Overrides:
        `isCachedFile` in class `ImageInputStreamImpl`
      Returns:
        `false`.
      See Also:
        `isCached()`, `isCachedMemory()`

    - #### isCachedMemory

          public boolean isCachedMemory()

      Returns `true` since this `ImageInputStream` maintains a main memory cache.
      Specified by:
        `isCachedMemory` in interface `ImageInputStream`
      Overrides:
        `isCachedMemory` in class `ImageInputStreamImpl`
      Returns:
        `true`.
      See Also:
        `isCached()`, `isCachedFile()`

    - #### close

          public void close()
                     throws IOException

      Closes this `MemoryCacheImageInputStream`, freeing the cache. The source `InputStream` is not closed.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `ImageInputStream`
      Overrides:
        `close` in class `ImageInputStreamImpl`
      Throws:
        `IOException` - if an I/O error occurs.

    - #### finalize

          protected void finalize()
                           throws Throwable

      Finalizes this object prior to garbage collection. The `close` method is called to close any open input source. This method should not be called from application code.
      Overrides:
        `finalize` in class `ImageInputStreamImpl`
      Throws:
        `Throwable` - if an error occurs during superclass finalization.
      See Also:
        `WeakReference`, `PhantomReference`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.